#ifdef VERTEX_SHADER

layout(location = 0) in vec2 a_pos;
layout(location = 1) in vec2 a_uv;
layout(location = 2) in float a_size;

out vec2 f_uv;
out float f_size;

void main()
{
    gl_Position = vec4(a_pos, 0.0, 1.0);
    f_uv = a_uv;
    f_size = a_size;
}

#endif

#ifdef FRAGMENT_SHADER

in vec2 f_uv;
in float f_size;
//out vec4 o_color;

uniform sampler2D image;

layout (location = 0) out vec4 FragColor;
layout (location = 1) out vec4 BrightColor;

void main()
{
    float val = texture(image, f_uv).r * f_size;
    float s = 1.0;
    float r = smoothstep(s, -s, val);
    FragColor = vec4(vec3(1.0), r);
    BrightColor = vec4(0.0, 0.0, 0.0, 1.0);
}

#endif
