#ifdef COMPUTE_SHADER

#define KERNEL_RADIUS 4
#define SHARED_TEXELS 40

// 32 + kernelradius * 2
layout(local_size_x = 40) in;

layout(rgba16f, binding = 0) uniform image2D image;

//uniform float kernel[5] = float[] (0.2270270270, 0.1945945946, 0.1216216216, 0.0540540541, 0.0162162162);
uniform float kernel[5] = float[] (0.20236, 0.179044, 0.124009, 0.067234, 0.028532);
uniform ivec2 img_size;

shared vec4 shared_texels[SHARED_TEXELS];

void main()
{
	ivec2 id = ivec2(gl_GlobalInvocationID.xy);
	ivec2 lookup = clamp(id - ivec2(KERNEL_RADIUS * (gl_WorkGroupID.x * 2 + 1), 0), ivec2(0,0), img_size - 1);
	
	shared_texels[gl_LocalInvocationID.x] = imageLoad(image, lookup);
	memoryBarrierShared();
	barrier();
	
	if(KERNEL_RADIUS <= gl_LocalInvocationID.x && gl_LocalInvocationID.x < 40 - KERNEL_RADIUS){
		vec3 result = vec3(0.0);
		result += shared_texels[gl_LocalInvocationID.x].rgb * kernel[0];
		for(int i = 1; i <= KERNEL_RADIUS; i++){
			result += shared_texels[gl_LocalInvocationID.x - i].rgb * kernel[i];
			result += shared_texels[gl_LocalInvocationID.x + i].rgb * kernel[i];
		}
		imageStore(image, lookup, vec4(result, 1.0));
	}
}

#endif
