#ifdef VERTEX_SHADER

layout(location = 0) in vec2 a_pos;

out vec2 f_uv;

void main()
{
    gl_Position = vec4(a_pos, 0.0, 1.0);
    f_uv = a_pos * 0.5 + vec2(0.5);
}

#endif

#ifdef FRAGMENT_SHADER

in vec2 f_uv;
out vec4 o_color;

uniform sampler2D image;

void main()
{
    float scale = 0.5;
    vec2 uv = f_uv / scale;
    ivec2 size = textureSize(image, 0);
    ivec2 pixel_pos = ivec2(vec2(uv) * size);
    float val_hard = texelFetch(image, pixel_pos, 0).r;

    float s = 1.5 / scale;
    float r;
    r = smoothstep(s, -s, val_hard);

    float val = texture(image, uv).r;
    r = step(val, 0.0);
    r = smoothstep(s, -s, val);

    o_color = vec4(r);


    /*
    r = val_hard/20;
    o_color = vec4(r);
    if (val > 10.8) {
        o_color = vec4(0, 1, 0, 0);
    }
    */

}

#endif
