#ifdef VERTEX_SHADER

layout(location = 0) in vec3 vertices;

layout (std140, binding = 1) uniform Camera {
    mat4 view;
    mat4 view_inv;
    mat4 projection;
    mat4 projection_inv;
    mat4 viewProjection;
    vec3 camera_position;
    vec4 fov_near_far;
    uvec4 resolution;
    float time;
};

void main()
{
    gl_Position = viewProjection * vec4(vertices, 1.0);
}

#endif

#ifdef FRAGMENT_SHADER

uniform vec3 color;

layout (location = 0) out vec4 FragColor;
layout (location = 1) out vec4 BrightColor;

void main()
{
    FragColor = vec4(color, 1.0);
    BrightColor = vec4(0.0, 0.0, 0.0, 0.0);
}

#endif
